/*
CRM API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package crmapi

import (
	"encoding/json"
)

// checks if the AddressById200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AddressById200Response{}

// AddressById200Response struct for AddressById200Response
type AddressById200Response struct {
	Id *string `json:"id,omitempty"`
	Phase *int64 `json:"phase,omitempty"`
	Plz *int64 `json:"plz,omitempty"`
	District *string `json:"district,omitempty"`
	City *string `json:"city,omitempty"`
	Street *string `json:"street,omitempty"`
	HouseNumber *int64 `json:"house_number,omitempty"`
	HouseNumberVariant *string `json:"house_number_variant,omitempty"`
	Lat *string `json:"lat,omitempty"`
	Lng *string `json:"lng,omitempty"`
	Signatures *int32 `json:"signatures,omitempty"`
}

// NewAddressById200Response instantiates a new AddressById200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAddressById200Response() *AddressById200Response {
	this := AddressById200Response{}
	return &this
}

// NewAddressById200ResponseWithDefaults instantiates a new AddressById200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAddressById200ResponseWithDefaults() *AddressById200Response {
	this := AddressById200Response{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *AddressById200Response) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *AddressById200Response) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *AddressById200Response) SetId(v string) {
	o.Id = &v
}

// GetPhase returns the Phase field value if set, zero value otherwise.
func (o *AddressById200Response) GetPhase() int64 {
	if o == nil || IsNil(o.Phase) {
		var ret int64
		return ret
	}
	return *o.Phase
}

// GetPhaseOk returns a tuple with the Phase field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetPhaseOk() (*int64, bool) {
	if o == nil || IsNil(o.Phase) {
		return nil, false
	}
	return o.Phase, true
}

// HasPhase returns a boolean if a field has been set.
func (o *AddressById200Response) HasPhase() bool {
	if o != nil && !IsNil(o.Phase) {
		return true
	}

	return false
}

// SetPhase gets a reference to the given int64 and assigns it to the Phase field.
func (o *AddressById200Response) SetPhase(v int64) {
	o.Phase = &v
}

// GetPlz returns the Plz field value if set, zero value otherwise.
func (o *AddressById200Response) GetPlz() int64 {
	if o == nil || IsNil(o.Plz) {
		var ret int64
		return ret
	}
	return *o.Plz
}

// GetPlzOk returns a tuple with the Plz field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetPlzOk() (*int64, bool) {
	if o == nil || IsNil(o.Plz) {
		return nil, false
	}
	return o.Plz, true
}

// HasPlz returns a boolean if a field has been set.
func (o *AddressById200Response) HasPlz() bool {
	if o != nil && !IsNil(o.Plz) {
		return true
	}

	return false
}

// SetPlz gets a reference to the given int64 and assigns it to the Plz field.
func (o *AddressById200Response) SetPlz(v int64) {
	o.Plz = &v
}

// GetDistrict returns the District field value if set, zero value otherwise.
func (o *AddressById200Response) GetDistrict() string {
	if o == nil || IsNil(o.District) {
		var ret string
		return ret
	}
	return *o.District
}

// GetDistrictOk returns a tuple with the District field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetDistrictOk() (*string, bool) {
	if o == nil || IsNil(o.District) {
		return nil, false
	}
	return o.District, true
}

// HasDistrict returns a boolean if a field has been set.
func (o *AddressById200Response) HasDistrict() bool {
	if o != nil && !IsNil(o.District) {
		return true
	}

	return false
}

// SetDistrict gets a reference to the given string and assigns it to the District field.
func (o *AddressById200Response) SetDistrict(v string) {
	o.District = &v
}

// GetCity returns the City field value if set, zero value otherwise.
func (o *AddressById200Response) GetCity() string {
	if o == nil || IsNil(o.City) {
		var ret string
		return ret
	}
	return *o.City
}

// GetCityOk returns a tuple with the City field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetCityOk() (*string, bool) {
	if o == nil || IsNil(o.City) {
		return nil, false
	}
	return o.City, true
}

// HasCity returns a boolean if a field has been set.
func (o *AddressById200Response) HasCity() bool {
	if o != nil && !IsNil(o.City) {
		return true
	}

	return false
}

// SetCity gets a reference to the given string and assigns it to the City field.
func (o *AddressById200Response) SetCity(v string) {
	o.City = &v
}

// GetStreet returns the Street field value if set, zero value otherwise.
func (o *AddressById200Response) GetStreet() string {
	if o == nil || IsNil(o.Street) {
		var ret string
		return ret
	}
	return *o.Street
}

// GetStreetOk returns a tuple with the Street field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetStreetOk() (*string, bool) {
	if o == nil || IsNil(o.Street) {
		return nil, false
	}
	return o.Street, true
}

// HasStreet returns a boolean if a field has been set.
func (o *AddressById200Response) HasStreet() bool {
	if o != nil && !IsNil(o.Street) {
		return true
	}

	return false
}

// SetStreet gets a reference to the given string and assigns it to the Street field.
func (o *AddressById200Response) SetStreet(v string) {
	o.Street = &v
}

// GetHouseNumber returns the HouseNumber field value if set, zero value otherwise.
func (o *AddressById200Response) GetHouseNumber() int64 {
	if o == nil || IsNil(o.HouseNumber) {
		var ret int64
		return ret
	}
	return *o.HouseNumber
}

// GetHouseNumberOk returns a tuple with the HouseNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetHouseNumberOk() (*int64, bool) {
	if o == nil || IsNil(o.HouseNumber) {
		return nil, false
	}
	return o.HouseNumber, true
}

// HasHouseNumber returns a boolean if a field has been set.
func (o *AddressById200Response) HasHouseNumber() bool {
	if o != nil && !IsNil(o.HouseNumber) {
		return true
	}

	return false
}

// SetHouseNumber gets a reference to the given int64 and assigns it to the HouseNumber field.
func (o *AddressById200Response) SetHouseNumber(v int64) {
	o.HouseNumber = &v
}

// GetHouseNumberVariant returns the HouseNumberVariant field value if set, zero value otherwise.
func (o *AddressById200Response) GetHouseNumberVariant() string {
	if o == nil || IsNil(o.HouseNumberVariant) {
		var ret string
		return ret
	}
	return *o.HouseNumberVariant
}

// GetHouseNumberVariantOk returns a tuple with the HouseNumberVariant field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetHouseNumberVariantOk() (*string, bool) {
	if o == nil || IsNil(o.HouseNumberVariant) {
		return nil, false
	}
	return o.HouseNumberVariant, true
}

// HasHouseNumberVariant returns a boolean if a field has been set.
func (o *AddressById200Response) HasHouseNumberVariant() bool {
	if o != nil && !IsNil(o.HouseNumberVariant) {
		return true
	}

	return false
}

// SetHouseNumberVariant gets a reference to the given string and assigns it to the HouseNumberVariant field.
func (o *AddressById200Response) SetHouseNumberVariant(v string) {
	o.HouseNumberVariant = &v
}

// GetLat returns the Lat field value if set, zero value otherwise.
func (o *AddressById200Response) GetLat() string {
	if o == nil || IsNil(o.Lat) {
		var ret string
		return ret
	}
	return *o.Lat
}

// GetLatOk returns a tuple with the Lat field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetLatOk() (*string, bool) {
	if o == nil || IsNil(o.Lat) {
		return nil, false
	}
	return o.Lat, true
}

// HasLat returns a boolean if a field has been set.
func (o *AddressById200Response) HasLat() bool {
	if o != nil && !IsNil(o.Lat) {
		return true
	}

	return false
}

// SetLat gets a reference to the given string and assigns it to the Lat field.
func (o *AddressById200Response) SetLat(v string) {
	o.Lat = &v
}

// GetLng returns the Lng field value if set, zero value otherwise.
func (o *AddressById200Response) GetLng() string {
	if o == nil || IsNil(o.Lng) {
		var ret string
		return ret
	}
	return *o.Lng
}

// GetLngOk returns a tuple with the Lng field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetLngOk() (*string, bool) {
	if o == nil || IsNil(o.Lng) {
		return nil, false
	}
	return o.Lng, true
}

// HasLng returns a boolean if a field has been set.
func (o *AddressById200Response) HasLng() bool {
	if o != nil && !IsNil(o.Lng) {
		return true
	}

	return false
}

// SetLng gets a reference to the given string and assigns it to the Lng field.
func (o *AddressById200Response) SetLng(v string) {
	o.Lng = &v
}

// GetSignatures returns the Signatures field value if set, zero value otherwise.
func (o *AddressById200Response) GetSignatures() int32 {
	if o == nil || IsNil(o.Signatures) {
		var ret int32
		return ret
	}
	return *o.Signatures
}

// GetSignaturesOk returns a tuple with the Signatures field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddressById200Response) GetSignaturesOk() (*int32, bool) {
	if o == nil || IsNil(o.Signatures) {
		return nil, false
	}
	return o.Signatures, true
}

// HasSignatures returns a boolean if a field has been set.
func (o *AddressById200Response) HasSignatures() bool {
	if o != nil && !IsNil(o.Signatures) {
		return true
	}

	return false
}

// SetSignatures gets a reference to the given int32 and assigns it to the Signatures field.
func (o *AddressById200Response) SetSignatures(v int32) {
	o.Signatures = &v
}

func (o AddressById200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AddressById200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Phase) {
		toSerialize["phase"] = o.Phase
	}
	if !IsNil(o.Plz) {
		toSerialize["plz"] = o.Plz
	}
	if !IsNil(o.District) {
		toSerialize["district"] = o.District
	}
	if !IsNil(o.City) {
		toSerialize["city"] = o.City
	}
	if !IsNil(o.Street) {
		toSerialize["street"] = o.Street
	}
	if !IsNil(o.HouseNumber) {
		toSerialize["house_number"] = o.HouseNumber
	}
	if !IsNil(o.HouseNumberVariant) {
		toSerialize["house_number_variant"] = o.HouseNumberVariant
	}
	if !IsNil(o.Lat) {
		toSerialize["lat"] = o.Lat
	}
	if !IsNil(o.Lng) {
		toSerialize["lng"] = o.Lng
	}
	if !IsNil(o.Signatures) {
		toSerialize["signatures"] = o.Signatures
	}
	return toSerialize, nil
}

type NullableAddressById200Response struct {
	value *AddressById200Response
	isSet bool
}

func (v NullableAddressById200Response) Get() *AddressById200Response {
	return v.value
}

func (v *NullableAddressById200Response) Set(val *AddressById200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableAddressById200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableAddressById200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAddressById200Response(val *AddressById200Response) *NullableAddressById200Response {
	return &NullableAddressById200Response{value: val, isSet: true}
}

func (v NullableAddressById200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAddressById200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


